// This class does all teh Matrix math for a 3x3 matrix
//
// Author: Dan Fleck

#pragma once

#include "SVD.h"

void cross(float a[3], float b[3], float dest[3]);


class Matrix3 {

public:
	Matrix3::Matrix3(float []);
	Matrix3::Matrix3(void);
	void Matrix3::getRotationAngles(float *xr, float *yr, float *zr);
	void Matrix3::multiply(Matrix3 * o);
	void Matrix3::multiply(Matrix3 * o, Matrix3 * dest);
	void Matrix3::set(int index, float val);
	void Matrix3::transpose(Matrix3 * dest);
	void Matrix3::multiply(float v[3], float dest[3]);
	void Matrix3::add(Matrix3 * o);
	void Matrix3::reorthogonalize();
	void Matrix3::copy(Matrix3 * src);
	void Matrix3::normalize(float v[3]);
	void Matrix3::OrthonormalizeOrientation();
	
private:
	float m[9]; // The matrix
	float piOver2; // Constant
	float radToDeg; // To convert
	float prevX,prevY, prevZ; // DEBUG Value

	bool Matrix3::closeTo(float num, int val);
	void Matrix3::debugShowStr(float f);
	void Matrix3::getClose(float prev, float * newVal, float modifier);
};